Imports System.Management
Imports System.ComponentModel
Module Shutdown

    Public ErrMsg As String
    Const LOGOFF As Integer = 0
    Const REBOOT As Integer = 2
    Const SHUTDOWN As Integer = 8

    Function ShutdownPC(ByVal PC_Name As String, ByVal forced As Boolean) As Boolean
        Dim wmi As ManagementClass
        Dim obj As ManagementObject
        Dim inParams, outParams As ManagementBaseObject
        Dim Result, Flag As Integer
        Dim junk As String

        If Not SetPrivileges(PC_Name) Then
            ErrMsg = "Can't set privileges"
            Return False
        End If

        Flag = SHUTDOWN
        If forced = True Then
            Flag += 4
        End If
        ErrMsg = ""
        Try
            wmi = New ManagementClass("\\" & PC_Name & "\root\cimv2:Win32_OperatingSystem")
            wmi.Scope.Options.EnablePrivileges = True
            For Each obj In wmi.GetInstances()
                ' prime the pump
                junk = obj("Description")

                ' Get an input parameters object for this method
                inParams = obj.GetMethodParameters("Win32Shutdown")

                ' fill 'em in
                inParams("Flags") = Flag
                inParams("Reserved") = 0

                ' do it!
                outParams = obj.InvokeMethod("Win32Shutdown", inParams, Nothing)
                Result = Convert.ToInt32(outParams("returnValue"))
                If Result <> 0 Then
                    Dim w32err As New Win32Exception(Result)
                    ErrMsg = w32err.Message
                    wmi.Dispose()
                    Return False
                End If
            Next
            wmi.Dispose()
        Catch ex As Exception
            ErrMsg = ex.Message
            Return False
        End Try

        Return True
    End Function
End Module
